#ifndef BLA_H
#define BLA_H

#ifndef MS_DOS
#define DIR_SEPARATOR '/'
#else
#define DIR_SEPARATOR '\\'
#endif /* MS_DOS */

#define VAR 1
#define STR 2
#define CONCAT 3
#define ENUM 4

#ifndef TRUE
#define TRUE 1
#endif /* TRUE */
#ifndef FALSE
#define FALSE 0
#endif /* FALSE */

#define MAX_ARG_LEN 5 /* Con esto se pueden pasar 9999 parametros */
#define MAX_END_LEN 5 /* Con esto cada variable puede tener 9999 desinencias */

#define NO_ENDINGS -1    /* Especifica a eval que no queremos desinencias */

struct exprec {
  int type;
  union {
    char *val;
    struct exprec *list;
  } value;
  struct exprec *endings;
  char *end;  
  struct exprec *next;
};
typedef struct exprec exprec;

struct symrec {
  char *key;
  exprec *value;
  struct symrec *endtbl;
  struct symrec *next;
};
typedef struct symrec symrec;

/* Definicion de las funciones */
exprec *newexpr(int, char*);
exprec *mklist(int, exprec*, exprec*);
exprec *append(exprec*, exprec*);
exprec *exprcat(exprec*, exprec*);
exprec *addendings(exprec*, exprec*);
void selending(exprec*, char*);
symrec *putending(symrec*, char*);
symrec *putvar(symrec*, char*, symrec*, exprec*);
exprec *getvar(symrec*, char*, symrec**);
char *eval(char*, size_t*, exprec*, int, int);
void eval_print(exprec*);
exprec *eval_expr(exprec*);
int exprlen(exprec*);
void repeat(int, exprec*);
void repeat_var(symrec*, char*, exprec*);
exprec *nth(int, exprec*);
char *str_print(char*, size_t*, int, char*);
void *xmalloc(size_t);
void yyinit(char*);
void yyinclude(char*);
void yyset(char*);
void yyerror(char*);
int yyparse(void);
int yylex(void);
#endif /* BLA_H */




