/*
 * Fichero Bison para 'bla'
 * Alejandro Luque, 2000
 */
 
%{
#include "stdlib.h"
#include "bla.h"
#include "string.h"
#define YYERROR_VERBOSE

extern symrec *gl_symtbl;
%}

%union {
  char *val;
  exprec *eptr;
  symrec *stptr;
}

%token <val> STRING 
%token <val> ID
%token INCLUDE
%token DO
%type <eptr> exprlist expr
%type <stptr> endtable

%nonassoc '[' ']'
%nonassoc '='
%left '+'
%left ','

%%
input: /* empty input */
     | input stmt
     | input error
;

stmt: ID '=' expr ';'         {gl_symtbl = putvar(gl_symtbl, $1, NULL, $3);}
    | ID '[' endtable ']' '=' expr ';'
                              {gl_symtbl = putvar(gl_symtbl, $1, $3, $6);}
    | '<' expr '>' ';'        {eval_print($2);}
    | INCLUDE STRING ';'      {yyinclude($2);}
    | DO STRING '<' expr '>' ';'      
                              {repeat(atoi($2), $4);}
    | DO ID '<' expr '>' ';'  {repeat_var(gl_symtbl, $2, $4);}
    | error ';'
;

exprlist: expr ',' expr       {$$ = mklist(ENUM, $1, $3);}
        | exprlist ',' expr   {$$ = append($1, $3);}
;

endtable: ID ',' ID           {$$ = putending(NULL, $1); 
                               $$ = putending($$, $3);} 
        | endtable ','  ID    {$$ = putending($$, $3);}
;

expr: ID                      {$$ = newexpr(VAR, $1);}
    | STRING                  {$$ = newexpr(STR, $1);}
    | '{' exprlist '}'        {$$ = $2}
    | '{' expr '}'            {$$ = $2} 
    | expr '+' expr           {$$ = exprcat($1, $3);}
    | expr '[' exprlist ']'   {$$ = addendings($1, $3);}
    | '&' ID '[' ID ']'       {$$ = newexpr(VAR, $2); selending($$, $4);}
    | '<' expr '>'            {$$ = eval_expr($2);} 
;
%%



